Index: trunk/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1314)
+++ trunk/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1321)
@@ -64,22 +64,50 @@
 {
 #if NH_MV
-  for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++) 
-  {
-    m_layerIdToDecIdx[i] = -1; 
-    m_layerInitilizedFlags[i] = false; 
-  }
+  for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++)
+  {
+    m_layerIdToDecIdx                     [i] = -1;
+    m_layerInitilizedFlag                 [i] = false;
+    m_eosInLayer                          [i] = false;
+    m_firstPicInLayerDecodedFlag          [i] = false;
+    m_pocDecrementedInDpbFlag             [i] = false;
+    m_decodingOrder                       [i] = 0;
+    m_lastPresentPocResetIdc              [i] = MIN_INT;
+    m_firstPicInPocResettingPeriodReceived[i] = true;
+    m_noRaslOutputFlagAssocIrap           [i] = false;
+  }
+
+  m_curPic                          = NULL;
+  m_vps                             = NULL;
+  m_sps                             = NULL;
+  m_pps                             = NULL;
+  m_initilizedFromVPS               = false;
+  m_firstSliceInBitstream           = true;
+  m_newVpsActivatedbyCurAu          = false;
+  m_newVpsActivatedbyCurPic         = false;
+  m_handleCraAsBlaFlag              = false;
+  m_handleCraAsBlaFlagSetByExtMeans = false;
+  m_noClrasOutputFlag               = false;
+  m_noClrasOutputFlagSetByExtMeans  = false;
+  m_layerResetFlag                  = false;
+  m_totalNumofPicsReceived          = 0;
+  m_cvsStartFound                   = false;
 #endif
 #if NH_3D
-    m_pScaleOffsetFile  = 0;
+    m_pScaleOffsetFile              = 0;
 #endif
-
+}
+
+Void TAppDecTop::create()
+{
 #if NH_MV
-    m_markedForOutput = false; 
+#if ENC_DEC_TRACE
+  if ( g_hTrace == NULL )
+  {
+    g_hTrace = fopen( "TraceDec.txt", "wb" );
+    g_bJustDoIt = g_bEncDecTraceDisable;
+    g_nSymbolCounter = 0;
+  }
 #endif
-
-}
-
-Void TAppDecTop::create()
-{
+#endif
 }
 
@@ -115,5 +143,5 @@
   {
     free (m_pchScaleOffsetFile);
-    m_pchScaleOffsetFile = NULL; 
+    m_pchScaleOffsetFile = NULL;
   }
 #endif
@@ -132,10 +160,68 @@
  .
  */
+
+#if NH_MV
 Void TAppDecTop::decode()
 {
+  // create & initialize internal classes
+  xInitFileIO  ();
+  xCreateDecLib();
+  xInitDecLib  ();
+
+  InputByteStream bytestream(m_bitstreamFile);
+
+  while ( m_bitstreamFile )
+  {
+    AnnexBStats stats = AnnexBStats();
+    InputNALUnit nalu;
+
+    byteStreamNALUnit(bytestream, nalu.getBitstream().getFifo(), stats);
+
+    if (nalu.getBitstream().getFifo().empty())
+    {
+      /* this can happen if the following occur:
+       *  - empty input file
+       *  - two back-to-back start_code_prefixes
+       *  - start_code_prefix immediately followed by EOF
+       */
+      fprintf(stderr, "Warning: Attempt to decode an empty NAL unit\n");
+    }
+    else
+    {
+      read(nalu);
+
+      if ( m_printReceivedNalus )
+      {
+        std::cout << "Received NAL unit: ";
+        nalu.print();
+        std::cout << std::endl;
+      }
+
+      if ( xExtractAndRewrite( &nalu )
+          && nalu.m_nuhLayerId <= MAX_NUM_LAYER_IDS-1
+          && !(nalu.m_nalUnitType == NAL_UNIT_VPS && nalu.m_nuhLayerId > 0)
+          && !(nalu.m_nalUnitType == NAL_UNIT_EOB && nalu.m_nuhLayerId > 0)
+         )
+      {
+        xGetDecoderIdx( nalu.m_nuhLayerId , true );
+        if( nalu.isSlice() )
+        {
+          xProcessVclNalu   ( nalu );
+        }
+        else
+        {
+          xProcessNonVclNalu( nalu );
+        }
+      }
+    }
+  }
+ xTerminateDecoding();
+}
+#endif
+
+#if !NH_MV
+Void TAppDecTop::decode()
+{
   Int                 poc;
-#if NH_MV
-  poc = -1; 
-#endif
   TComList<TComPic*>* pcListPic = NULL;
 
@@ -146,11 +232,4 @@
     exit(EXIT_FAILURE);
   }
-#if NH_3D
-  if( m_pchScaleOffsetFile ) 
-  { 
-    m_pScaleOffsetFile = ::fopen( m_pchScaleOffsetFile, "wt" ); 
-    AOF( m_pScaleOffsetFile ); 
-  }
-#endif
 
   InputByteStream bytestream(bitstreamFile);
@@ -169,22 +248,9 @@
   xCreateDecLib();
   xInitDecLib  ();
-#if !NH_MV
+
   m_iPOCLastDisplay += m_iSkipFrame;      // set the last displayed POC correctly for skip forward.
 
   // main decoder loop
   Bool openedReconFile = false; // reconstruction file not yet opened. (must be performed after SPS is seen)
-#else
-
-  Int  pocCurrPic        = -MAX_INT;     
-  Int  pocLastPic        = -MAX_INT;   
-
-  Int  layerIdLastPic    = -MAX_INT; 
-  Int  layerIdCurrPic    = 0; 
-
-  Int  decIdxLastPic     = 0; 
-  Int  decIdxCurrPic     = 0; 
-
-  Bool firstSlice        = true; 
-#endif
   Bool loopFiltered = false;
 
@@ -201,9 +267,4 @@
     streampos location = bitstreamFile.tellg();
 #endif
-#if NH_MV
-#if ENC_DEC_TRACE
-    Int64 symCount = g_nSymbolCounter;
-#endif
-#endif
     AnnexBStats stats = AnnexBStats();
 
@@ -213,10 +274,4 @@
     // call actual decoding function
     Bool bNewPicture = false;
-#if NH_MV
-    Bool newSliceDiffPoc   = false;
-    Bool newSliceDiffLayer = false;
-    Bool sliceSkippedFlag  = false; 
-    Bool allLayersDecoded  = false;     
-#endif
     if (nalu.getBitstream().getFifo().empty())
     {
@@ -231,85 +286,12 @@
     {
       read(nalu);
-#if NH_MV      
-      if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) 
-          || !isNaluWithinTargetDecLayerIdSet(&nalu)
-          || nalu.m_nuhLayerId > MAX_NUM_LAYER_IDS-1
-          || (nalu.m_nalUnitType == NAL_UNIT_VPS && nalu.m_nuhLayerId > 0)           
-          || (nalu.m_nalUnitType == NAL_UNIT_EOB && nalu.m_nuhLayerId > 0)              
-         ) 
+
+      if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu)  )
       {
         bNewPicture = false;
-        if ( !bitstreamFile )
-        {
-          decIdxLastPic     = decIdxCurrPic; 
-        }
       }
       else
-      { 
-        Int decIdx     = xGetDecoderIdx( nalu.m_nuhLayerId , true );      
-        newSliceDiffLayer = nalu.isSlice() && ( nalu.m_nuhLayerId != layerIdCurrPic ) && !firstSlice;
-        newSliceDiffPoc   = m_tDecTop[decIdx]->decode(nalu, m_iSkipFrame, m_pocLastDisplay[decIdx], newSliceDiffLayer, sliceSkippedFlag );
-        // decode function only returns true when all of the following conditions are true
-        // - poc in particular layer changes
-        // - nalu does not belong to first slice in layer
-        // - nalu.isSlice() == true      
-
-        bNewPicture       = ( newSliceDiffLayer || newSliceDiffPoc ) && !sliceSkippedFlag; 
-        if ( nalu.isSlice() && firstSlice && !sliceSkippedFlag )        
-        {
-          layerIdCurrPic = nalu.m_nuhLayerId; 
-          pocCurrPic     = m_tDecTop[decIdx]->getCurrPoc(); 
-          decIdxCurrPic  = decIdx; 
-          firstSlice     = false; 
-
-          /// Use VPS activated by the first slice to determine OLS
-          m_vps = m_tDecTop[decIdx]->getActiveVPS( );
-          if ( m_targetDecLayerIdSetFileEmpty )
-          {            
-            if ( m_targetOptLayerSetIdx == -1 )
-            {
-              m_targetOptLayerSetIdx = m_tDecTop[decIdx]->getTargetOlsIdx(); 
-            }
-            else
-            {
-              assert( m_tDecTop[decIdx]->getTargetOlsIdx() == m_targetOptLayerSetIdx );
-            }
-
-            if ( m_targetOptLayerSetIdx < 0 || m_targetOptLayerSetIdx >= m_vps->getNumOutputLayerSets() )
-            {
-              fprintf(stderr, "\ntarget output layer set index must be in the range of 0 to %d, inclusive \n", m_vps->getNumOutputLayerSets() - 1 );            
-              exit(EXIT_FAILURE);
-            }
-            m_targetDecLayerIdSet = m_vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
-          }
-
-          if (m_outputVpsInfo )
-          {
-            m_vps->printScalabilityId();
-            m_vps->printLayerDependencies();
-            m_vps->printLayerSets();
-            m_vps->printPTL(); 
-          }
-        }        
-
-        if ( bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS )
-        { 
-          layerIdLastPic    = layerIdCurrPic; 
-          layerIdCurrPic    = nalu.m_nuhLayerId; 
-          pocLastPic        = pocCurrPic; 
-          pocCurrPic        = m_tDecTop[decIdx]->getCurrPoc(); 
-          decIdxLastPic     = decIdxCurrPic; 
-          decIdxCurrPic     = decIdx; 
-          allLayersDecoded = ( pocCurrPic != pocLastPic ) && ( nalu.m_nalUnitType != NAL_UNIT_EOS );
-        }
-#else
-      if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu)  )
-      {
-        bNewPicture = false;
-      }
-      else
       {
         bNewPicture = m_cTDecTop.decode(nalu, m_iSkipFrame, m_iPOCLastDisplay);
-#endif
         if (bNewPicture)
         {
@@ -327,17 +309,4 @@
           bytestream.reset();
 #endif
-#if H_MV_ENC_DEC_TRAC
-#if ENC_DEC_TRACE
-          const Bool resetCounter = false; 
-          if ( resetCounter )
-          {
-            g_nSymbolCounter  = symCount; // Only reset counter SH becomes traced twice
-          }
-          else
-          {
-            g_disableHLSTrace = true;     // Tracing of second parsing of SH is not carried out
-          }      
-#endif
-#endif
         }
       }
@@ -345,64 +314,27 @@
 
     if ( (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS) &&
-#if NH_MV      
-      !m_tDecTop[decIdxLastPic]->getFirstSliceInSequence () )
-#else
+
       !m_cTDecTop.getFirstSliceInSequence () )
-#endif
 
     {
       if (!loopFiltered || bitstreamFile)
       {
-#if NH_MV
-        assert( decIdxLastPic != -1 ); 
-        m_tDecTop[decIdxLastPic]->endPicDecoding(poc, pcListPic, m_targetDecLayerIdSet );
-        xMarkForOutput( allLayersDecoded, poc, layerIdLastPic ); 
-#else
         m_cTDecTop.executeLoopFilters(poc, pcListPic);
-#endif
       }
       loopFiltered = (nalu.m_nalUnitType == NAL_UNIT_EOS);
       if (nalu.m_nalUnitType == NAL_UNIT_EOS)
       {
-#if NH_MV      
-        m_tDecTop[decIdxLastPic]->setFirstSliceInSequence(true);
-#else
         m_cTDecTop.setFirstSliceInSequence(true);
-#endif
       }
     }
     else if ( (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS ) &&
-#if NH_MV      
-              m_tDecTop[decIdxLastPic]->getFirstSliceInSequence () ) 
-#else
-              m_cTDecTop.getFirstSliceInSequence () ) 
-#endif
-    {
-#if NH_MV      
-      m_tDecTop[decIdxLastPic]->setFirstSliceInPicture (true);
-#else
+              m_cTDecTop.getFirstSliceInSequence () )
+    {
       m_cTDecTop.setFirstSliceInPicture (true);
-#endif
-    }
-
-#if NH_3D
-    if ( allLayersDecoded || !bitstreamFile )
-    {
-      for( Int dI = 0; dI < m_numDecoders; dI++ )
-      {
-        TComPic* picLastCoded = m_ivPicLists.getPic( m_tDecTop[dI]->getLayerId(), pocLastPic );
-        assert( picLastCoded != NULL );        
-        picLastCoded->compressMotion(1);
-      }
-    }
-#endif
+   }
 
     if( pcListPic )
     {
-#if NH_MV
-      if ( m_pchReconFiles[decIdxLastPic] && !m_reconOpen[decIdxLastPic] )
-#else
       if ( m_pchReconFile && !openedReconFile )
-#endif
       {
         const BitDepths &bitDepths=pcListPic->front()->getPicSym()->getSPS().getBitDepths(); // use bit depths of first reconstructed picture.
@@ -414,33 +346,10 @@
           }
         }
-#if NH_MV
-        m_tVideoIOYuvReconFile[decIdxLastPic]->open( m_pchReconFiles[decIdxLastPic], true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
-        m_reconOpen[decIdxLastPic] = true;
+        m_cTVideoIOYuvReconFile.open( m_pchReconFile, true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
+        openedReconFile = true;
       }
       // write reconstruction to file
       if( bNewPicture )
       {
-        // Bumping after picture has been decoded
-#if ENC_DEC_TRACE
-        g_bJustDoIt = true;  
-        writeToTraceFile( "Bumping after decoding \n", g_decTracePicOutput  );         
-        g_bJustDoIt = false;  
-#endif
-        xWriteOutput( pcListPic, decIdxLastPic, nalu.m_temporalId );
-      }
-      if ( (bNewPicture || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_CRA) && m_tDecTop[decIdxLastPic]->getNoOutputPriorPicsFlag() )
-      {
-        m_tDecTop[decIdxLastPic]->checkNoOutputPriorPics( pcListPic );
-        m_tDecTop[decIdxLastPic]->setNoOutputPriorPicsFlag (false);
-      }
-
-      if ( bNewPicture && newSliceDiffPoc && 
-#else
-        m_cTVideoIOYuvReconFile.open( m_pchReconFile, true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
-        openedReconFile = true;
-      }
-      // write reconstruction to file
-      if( bNewPicture )
-      {
         xWriteOutput( pcListPic, nalu.m_temporalId );
       }
@@ -452,5 +361,4 @@
 
       if ( bNewPicture &&
-#endif
            (   nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR_W_RADL
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR_N_LP
@@ -459,56 +367,21 @@
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA_W_LP ) )
       {
-#if NH_MV
-        xFlushOutput( pcListPic, decIdxLastPic );
-#else
+
         xFlushOutput( pcListPic );
-#endif
       }
       if (nalu.m_nalUnitType == NAL_UNIT_EOS)
       {
-#if NH_MV
-        xWriteOutput( pcListPic, decIdxCurrPic, nalu.m_temporalId );
-#else
+
         xWriteOutput( pcListPic, nalu.m_temporalId );
-#endif
-#if NH_MV
-        m_tDecTop[decIdxCurrPic]->setFirstSliceInPicture (false);
-#else
         m_cTDecTop.setFirstSliceInPicture (false);
-#endif
       }
       // write reconstruction to file -- for additional bumping as defined in C.5.2.3
-#if NH_MV
-      // Above comment seems to be wrong
-#endif
       if(!bNewPicture && nalu.m_nalUnitType >= NAL_UNIT_CODED_SLICE_TRAIL_N && nalu.m_nalUnitType <= NAL_UNIT_RESERVED_VCL31)
       {
-#if NH_MV        
-        // Bumping after reference picture set has been applied (here after first vcl nalu. 
-#if ENC_DEC_TRACE
-        g_bJustDoIt = true;  
-        writeToTraceFile( "Bumping after reference picture set has been applied \n", g_decTracePicOutput  );         
-        g_bJustDoIt = false;  
-#endif
-
-        xWriteOutput( m_tDecTop[decIdxCurrPic]->getListPic(), decIdxCurrPic, nalu.m_temporalId );
-#else
         xWriteOutput( pcListPic, nalu.m_temporalId );
-#endif
-      }
-    }
-  }
-#if NH_MV
-#if NH_3D
-  if( m_cCamParsCollector.isInitialized() )
-  {
-    m_cCamParsCollector.setSlice( 0 );
-  }
-#endif
-  for(UInt decIdx = 0; decIdx < m_numDecoders; decIdx++)
-  {
-    xFlushOutput( m_tDecTop[decIdx]->getListPic(), decIdx );
-  }
-#else  
+      }
+    }
+  }
+
   xFlushOutput( pcListPic );
   // delete buffers
@@ -516,6 +389,6 @@
   // destroy internal classes
   xDestroyDecLib();
+}
 #endif
-}
 
 // ====================================================================================================================
@@ -527,5 +400,5 @@
 #if NH_MV
   // initialize global variables
-  initROM();  
+  initROM();
 #if NH_3D_DMM
   initWedgeLists();
@@ -548,5 +421,5 @@
     {
       m_tVideoIOYuvReconFile[decIdx]->close();
-      delete m_tVideoIOYuvReconFile[decIdx]; 
+      delete m_tVideoIOYuvReconFile[decIdx];
       m_tVideoIOYuvReconFile[decIdx] = NULL ;
     }
@@ -554,8 +427,10 @@
     if( m_tDecTop[decIdx] )
     {
+#if !NH_MV
       m_tDecTop[decIdx]->deletePicBuffer();
+#endif
       m_tDecTop[decIdx]->destroy() ;
     }
-    delete m_tDecTop[decIdx] ; 
+    delete m_tDecTop[decIdx] ;
     m_tDecTop[decIdx] = NULL ;
   }
@@ -571,7 +446,7 @@
 #if NH_3D
   m_cCamParsCollector.uninit();
-  if( m_pScaleOffsetFile ) 
-  { 
-    ::fclose( m_pScaleOffsetFile ); 
+  if( m_pScaleOffsetFile )
+  {
+    ::fclose( m_pScaleOffsetFile );
   }
 #endif
@@ -584,5 +459,7 @@
   m_cCamParsCollector.setCodeScaleOffsetFile( m_pScaleOffsetFile );
 #endif
-#if !NH_MV
+#if NH_MV
+  m_dpb.setPrintPicOutput(m_printPicOutput);
+#else
   // initialize decoder class
   m_cTDecTop.init();
@@ -599,12 +476,10 @@
 }
 
+
+#if !NH_MV
 /** \param pcListPic list of pictures to be written to file
     \param tId       temporal sub-layer ID
  */
-#if NH_MV
-Void TAppDecTop::xWriteOutput( TComList<TComPic*>* pcListPic, Int decIdx, Int tId )
-#else
 Void TAppDecTop::xWriteOutput( TComList<TComPic*>* pcListPic, UInt tId )
-#endif
 {
   if (pcListPic->empty())
@@ -625,10 +500,10 @@
   {
     numReorderPicsHighestTid = activeSPS->getNumReorderPics(maxNrSublayers-1);
-    maxDecPicBufferingHighestTid =  activeSPS->getMaxDecPicBuffering(maxNrSublayers-1); 
+    maxDecPicBufferingHighestTid =  activeSPS->getMaxDecPicBuffering(maxNrSublayers-1);
   }
   else
   {
     numReorderPicsHighestTid = activeSPS->getNumReorderPics(m_iMaxTemporalLayer);
-    maxDecPicBufferingHighestTid = activeSPS->getMaxDecPicBuffering(m_iMaxTemporalLayer); 
+    maxDecPicBufferingHighestTid = activeSPS->getMaxDecPicBuffering(m_iMaxTemporalLayer);
   }
 
@@ -636,9 +511,5 @@
   {
     TComPic* pcPic = *(iterPic);
-#if NH_MV
-    if(pcPic->getOutputMark() && pcPic->getPOC() > m_pocLastDisplay[decIdx])
-#else
     if(pcPic->getOutputMark() && pcPic->getPOC() > m_iPOCLastDisplay)
-#endif
     {
        numPicsNotYetDisplayed++;
@@ -671,23 +542,12 @@
       TComPic* pcPicBottom = *(iterPic);
 
-#if NH_MV
-      if ( pcPicTop->getOutputMark() && pcPicBottom->getOutputMark() &&
-        (numPicsNotYetDisplayed >  numReorderPicsHighestTid || dpbFullness > maxDecPicBufferingHighestTid) &&
-        (!(pcPicTop->getPOC()%2) && pcPicBottom->getPOC() == pcPicTop->getPOC()+1) &&
-        (pcPicTop->getPOC() == m_pocLastDisplay[decIdx]+1 || m_pocLastDisplay[decIdx] < 0))
-#else
       if ( pcPicTop->getOutputMark() && pcPicBottom->getOutputMark() &&
           (numPicsNotYetDisplayed >  numReorderPicsHighestTid || dpbFullness > maxDecPicBufferingHighestTid) &&
           (!(pcPicTop->getPOC()%2) && pcPicBottom->getPOC() == pcPicTop->getPOC()+1) &&
           (pcPicTop->getPOC() == m_iPOCLastDisplay+1 || m_iPOCLastDisplay < 0))
-#endif
       {
         // write to file
         numPicsNotYetDisplayed = numPicsNotYetDisplayed-2;
-#if NH_MV
-      if ( m_pchReconFiles[decIdx] )
-#else
         if ( m_pchReconFile )
-#endif
         {
           const Window &conf = pcPicTop->getConformanceWindow();
@@ -708,35 +568,15 @@
           if (display)
           {
-#if NH_MV
-        assert( conf   .getScaledFlag() );
-        assert( defDisp.getScaledFlag() );
-#if ENC_DEC_TRACE 
-        g_bJustDoIt = true;  
-        writeToTraceFile( "OutputPic Poc"   , pcPic->getPOC    (), g_decTracePicOutput  ); 
-        writeToTraceFile( "OutputPic LayerId", pcPic->getLayerId(), g_decTracePicOutput );         
-        g_bJustDoIt = false;  
-#endif
-        m_tVideoIOYuvReconFile[decIdx]->write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
-#else
         m_cTVideoIOYuvReconFile.write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
-#endif
                                            m_outputColourSpaceConvert,
                                            conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
                                            conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
                                            conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-#if NH_3D
-                                           conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), m_depth420OutputFlag && pcPicTop->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT, isTff );
-#else
                                            conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), NUM_CHROMA_FORMAT, isTff );
-#endif
           }
         }
 
         // update POC of display order
-#if NH_MV
-        m_pocLastDisplay[decIdx] = pcPic->getPOC();
-#else
         m_iPOCLastDisplay = pcPicBottom->getPOC();
-#endif
 
         // erase non-referenced picture in the reference picture list after display
@@ -768,11 +608,6 @@
       pcPic = *(iterPic);
 
-#if NH_MV
-      if(pcPic->getOutputMark() && pcPic->getPOC() > m_pocLastDisplay[decIdx] &&
-        (numPicsNotYetDisplayed >  numReorderPicsHighestTid || dpbFullness > maxDecPicBufferingHighestTid))
-#else      
       if(pcPic->getOutputMark() && pcPic->getPOC() > m_iPOCLastDisplay &&
         (numPicsNotYetDisplayed >  numReorderPicsHighestTid || dpbFullness > maxDecPicBufferingHighestTid))
-#endif
       {
         // write to file
@@ -782,44 +617,20 @@
           dpbFullness--;
         }
-#if NH_MV
-      if ( m_pchReconFiles[decIdx] )
-#else
         if ( m_pchReconFile )
-#endif
         {
           const Window &conf    = pcPic->getConformanceWindow();
           const Window defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
-#if NH_MV
-        assert( conf   .getScaledFlag() );
-        assert( defDisp.getScaledFlag() );
-#if ENC_DEC_TRACE
-        g_bJustDoIt = true;  
-        writeToTraceFile( "OutputPic Poc"   , pcPic->getPOC    (), g_decTracePicOutput  ); 
-        writeToTraceFile( "OutputPic LayerId", pcPic->getLayerId(), g_decTracePicOutput );         
-        g_bJustDoIt = false; 
-#endif
-        m_tVideoIOYuvReconFile[decIdx]->write( pcPic->getPicYuvRec(),
-#else
+
           m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(),
-#endif
                                          m_outputColourSpaceConvert,
                                          conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
                                          conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
                                          conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), 
-#if NH_3D
-                                          m_depth420OutputFlag && pcPic->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT,
-#else
-                                          NUM_CHROMA_FORMAT,
-#endif
-           m_bClipOutputVideoToRec709Range   );
+                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(),
+                                         NUM_CHROMA_FORMAT, m_bClipOutputVideoToRec709Range  );
         }
 
         // update POC of display order
-#if NH_MV
-        m_pocLastDisplay[decIdx] = pcPic->getPOC();
-#else
         m_iPOCLastDisplay = pcPic->getPOC();
-#endif
 
         // erase non-referenced picture in the reference picture list after display
@@ -832,7 +643,4 @@
         }
         pcPic->setOutputMark(false);
-#if NH_MV
-        pcPic->setPicOutputFlag(false);
-#endif
       }
 
@@ -844,9 +652,5 @@
 /** \param pcListPic list of pictures to be written to file
  */
-#if NH_MV
-Void TAppDecTop::xFlushOutput( TComList<TComPic*>* pcListPic, Int decIdx )
-#else
 Void TAppDecTop::xFlushOutput( TComList<TComPic*>* pcListPic )
-#endif
 {
   if(!pcListPic || pcListPic->empty())
@@ -873,43 +677,21 @@
       {
         // write to file
-#if NH_MV
-      if ( m_pchReconFiles[decIdx] )
-#else
+
         if ( m_pchReconFile )
-#endif
         {
           const Window &conf = pcPicTop->getConformanceWindow();
           const Window  defDisp = m_respectDefDispWindow ? pcPicTop->getDefDisplayWindow() : Window();
           const Bool isTff = pcPicTop->isTopField();
-#if NH_MV
-        assert( conf   .getScaledFlag() );
-        assert( defDisp.getScaledFlag() );
-#if ENC_DEC_TRACE
-        g_bJustDoIt = true;  
-        writeToTraceFile( "OutputPic Poc"   , pcPic->getPOC    (), g_decTracePicOutput  ); 
-        writeToTraceFile( "OutputPic LayerId", pcPic->getLayerId(), g_decTracePicOutput );         
-        g_bJustDoIt = false;  
-#endif
-        m_tVideoIOYuvReconFile[decIdx]->write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
-#else
           m_cTVideoIOYuvReconFile.write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
-#endif
                                          m_outputColourSpaceConvert,
                                          conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
                                          conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
                                          conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-#if NH_3D
-                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), m_depth420OutputFlag && pcPicTop->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT, isTff );
-#else
                                          conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), NUM_CHROMA_FORMAT, isTff );
-#endif
         }
 
         // update POC of display order
-#if NH_MV
-      m_pocLastDisplay[decIdx] = pcPic->getPOC();
-#else
         m_iPOCLastDisplay = pcPicBottom->getPOC();
-#endif        
+
         // erase non-referenced picture in the reference picture list after display
         if ( !pcPicTop->getSlice(0)->isReferenced() && pcPicTop->getReconMark() == true )
@@ -954,45 +736,19 @@
       {
         // write to file
-#if NH_MV
-      if ( m_pchReconFiles[decIdx] )
-#else
         if ( m_pchReconFile )
-#endif
         {
           const Window &conf    = pcPic->getConformanceWindow();
           const Window  defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
-#if NH_MV
-        assert( conf   .getScaledFlag() );
-        assert( defDisp.getScaledFlag() );
-#if ENC_DEC_TRACE
-        g_bJustDoIt = true;  
-        writeToTraceFile( "OutputPic Poc"   , pcPic->getPOC    (), g_decTracePicOutput  ); 
-        writeToTraceFile( "OutputPic LayerId", pcPic->getLayerId(), g_decTracePicOutput );         
-        g_bJustDoIt = false;  
-#endif
-        m_tVideoIOYuvReconFile[decIdx]->write( pcPic->getPicYuvRec(),
-#else
           m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(),
-#endif
                                          m_outputColourSpaceConvert,
                                          conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
                                          conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
                                          conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), 
-#if NH_3D
-                                         m_depth420OutputFlag && pcPic->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT
-#else
-                                         NUM_CHROMA_FORMAT
-#endif
-                                         , m_bClipOutputVideoToRec709Range);
+                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(),
+                                         NUM_CHROMA_FORMAT, m_bClipOutputVideoToRec709Range );
         }
 
         // update POC of display order
-#if NH_MV
-      m_pocLastDisplay[decIdx] = pcPic->getPOC();
-#else
         m_iPOCLastDisplay = pcPic->getPOC();
-#endif
-
         // erase non-referenced picture in the reference picture list after display
         if ( !pcPic->getSlice(0)->isReferenced() && pcPic->getReconMark() == true )
@@ -1004,9 +760,5 @@
         }
         pcPic->setOutputMark(false);
-#if NH_MV
-        pcPic->setPicOutputFlag(false);
-#endif
-      }
-#if !NH_MV
+      }
       if(pcPic != NULL)
       {
@@ -1015,19 +767,18 @@
         pcPic = NULL;
       }
-#endif
       iterPic++;
     }
   }
-#if NH_MV
-  m_pocLastDisplay[decIdx] = -MAX_INT;
-#else
   pcListPic->clear();
   m_iPOCLastDisplay = -MAX_INT;
+}
 #endif
-}
-
 /** \param nalu Input nalu to check whether its LayerId is within targetDecLayerIdSet
  */
+#if NH_MV
+Bool TAppDecTop::xIsNaluInTargetDecLayerIdSet( InputNALUnit* nalu )
+#else
 Bool TAppDecTop::isNaluWithinTargetDecLayerIdSet( InputNALUnit* nalu )
+#endif
 {
   if ( m_targetDecLayerIdSet.size() == 0 ) // By default, the set is empty, meaning all LayerIds are allowed
